/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import TwitterCore 1.0
import Rocket 1.0

Item {
    id: root
    property bool done: false

    property string cacheSource: "";

    Image {
        id: cacheImage
        visible: false;

        function loadImage() {
            if (source == "") {
                cacheImage.source = thumbnailCacher.get(root.cacheSource);// || (networkConfigurationManager.online ? root.cacheSource : root.cacheSource)
            }
        }

        onStatusChanged: {
            if(status == Image.Ready){
                if(source == root.cacheSource)
                    thumbnailCacher.cache(root.cacheSource, cacheImage)
            }
        }

        Component.onCompleted: {
            cacheImage.loadImage();
        }
    }

    property ConfItem publishToEventFeedConf: ConfItem { id: publishToFeed; key: '/apps/ControlPanel/Rocket/EventFeedEnable' }
    property bool publishToEventFeed: publishToEventFeedConf.value

    //Component.onCompleted:
    HomeTimelineModel {
        id: model

        count: 50
        sortKey: 'id_str'
        since_id: settings.readData('EventFeed/maxReadIdStr', '')// == '' ? model.get(0).id_str : model.get(0).id_str //settings.readData('EventFeed/maxReadIdStr', '');

        onLoadingChanged: {
            if (loading) {
                //                console.debug('since_id', since_id)
            } else {
                if (model.size > 0 && model.get(0).id_str !== settings.readData('EventFeed/maxReadIdStr', '') && publishToEventFeed) {
                    for(var i = 0; i < model.size; i++)
                    {
                        var imageCacher = model.get(i);
                        cacheSource = imageCacher.user.profile_image_url;//'http://api.twitter.com/1/users/profile_image?screen_name='.concat(item.user.screen_name).concat('&size=normal');
                        cacheImage.loadImage();
                    }
                    for(var i = 0; i < model.size; i++)
                    {
                        var component = eventFeed.createObject(window);
                        var item = model.get(i);
                        cacheSource = item.user.profile_image_url;//'http://api.twitter.com/1/users/profile_image?screen_name='.concat(item.user.screen_name).concat('&size=normal');
                        cacheImage.loadImage();
                        component.icon = thumbnailCacher.getForFeed(cacheSource);
                        component.title = item.user.screen_name;
                        component.body = item.plain_text;
                        component.timestamp = new Date(item.created_at);
                        component.action = "rocket://status/"+item.id_str;
                        component.publish()
                    }
                    settings.saveData('EventFeed/maxReadIdStr', model.get(0).id_str)
                }
                root.done = true
            }
        }
    }
}
