/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1

Item {
    id: root
    height: 0
    width: ListView.view.width

    Item {
        id: container
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.bottom: parent.top
        anchors.bottomMargin: 24
        height: pullIcon.height
        width: pullIcon.width + textColumn.width + textColumn.anchors.leftMargin
        visible: root.ListView.view.__wasAtYBeginning && root.ListView.view.__scrollStartedAt - root.ListView.view.contentY > 10

        Image {
            id: pullIcon
            anchors.left: parent.left
            source: settings.invertedTheme ? "../images/refresh.png" : "../images/refresh-white.png"
            sourceSize.width: 16
            sourceSize.height: 16
            rotation: visible && root.ListView.view.__scrollStartedAt - root.ListView.view.contentY > 100 ? 135 : 45

            Behavior on rotation { NumberAnimation{ duration: 250 } }
        }

        Column {
            id: textColumn
            width: pullText.width
            height: childrenRect.height
            anchors.verticalCenter: parent.verticalCenter
            anchors.left: pullIcon.right
            anchors.leftMargin: 16

            Text {
                id: pullText
                font.pixelSize: constants.fontDefault
                color: constants.color_text_d
                text: visible && root.ListView.view.__scrollStartedAt - root.ListView.view.contentY > 100 ?
                          "Release to refresh" : "Pull down to refresh"
            }

            /*Text {
                id: lastUpdateText
                font.pixelSize: constant.fontSizeSmall
                color: constant.colorMid
                visible: container.visible && root.ListView.view.lastUpdate
                onVisibleChanged: {
                    if(visible) text = "Last update: " + Calculate.timeDiff(root.ListView.view.lastUpdate)
                }
            }*/
        }
    }
}
