﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */
import QtQuick 1.1
import com.nokia.meego 1.0

MouseArea {
    id: root
    width: 100
    height: (screen.currentOrientation === Screen.Portrait) ? 72 : 64;

    property alias text: title.text
    property alias busy: busy.running
    property alias newtweet: btnNewTweet.visible
    property alias homeButton: btnHome.visible

    property variant user: ""

    property bool centerBusyIndicator: false

    Rectangle {
        y: 0
        height: 1
        width: parent.width
        color: "#525152"
    }
    Rectangle {
        y: 1
        height: root.height - 1
        width: parent.width
        gradient: Gradient {
            GradientStop {
                color: "#313031"
                position: 0
            }
            GradientStop {
                color: "#101010"
                position: 1
            }
        }
    }

    ToolIcon {
        id: btnHome
        anchors {
            left: parent.left
            leftMargin: 0
            verticalCenter: parent.verticalCenter
        }
        iconSource: theme.inverted ? '../images/home-white.png' : '../images/home-white.png'
        //enabled: (pageStack !== undefined) && (pageStack !== null) && pageStack.depth > 1
        onClicked: {
            /*if (sideBar.width == 0)
                sideBar.width = 400
            else
                sideBar.width = 0;*/
            pageStack.pop(mainPage)
        }
    }

    Label {
        id: title
        anchors {
            left: btnHome.right
            leftMargin: 0
            verticalCenter: parent.verticalCenter
        }
        z: 9999
        color: 'white'
        font.bold: false
        font.pixelSize: 32
        platformStyle: LabelStyle {
            textColor: "white"
        }
    }

    Image {
        id: verifiedIcon
        anchors.left: title.right
        anchors.leftMargin: 8
        anchors.top: title.top
        source: "../images/verified.png"
        visible: {
            if (user.verified) {
                return true;
            } else {
                return false;
            }
        }
    }

    /*Rectangle {
        x: 0;
        y: (screen.currentOrientation === Screen.Portrait) ? 71 : 63;
        width: parent.width
        height: 1
        color: "#4b4b4b"
    }*/

    BusyIndicator {
        id: busy
        z: 1005
        anchors.verticalCenter: parent.verticalCenter
        platformStyle: BusyIndicatorStyle {
            spinnerFrames: "image://theme/spinnerinverted"
        }
        visible: running
    }

    ToolIcon {
        id: btnNewTweet
        anchors.verticalCenter: parent.verticalCenter
        anchors.right: parent.right
        anchors.rightMargin: 0
        z: 999
        //iconSource: 'image://theme/icon-m-toolbar-new-email'.concat(theme.inverted ? "-white" : "-white")
        iconSource: '../images/newtweet.png'
        enabled: test.ok
        visible: !busy.visible
        onClicked: {
            if (menu.status !== DialogStatus.Closed) menu.close()
            pageStack.push(tweetPage)
        }
    }

    StateGroup {
        states: [
            State {
                name: "center"
                when: centerBusyIndicator == true;
                PropertyChanges {
                    target: busy
                    anchors.horizontalCenter: root.horizontalCenter
                }
            },
            State {
                name: "right"
                when: centerBusyIndicator == false;
                PropertyChanges {
                    target: busy
                    anchors.right: root.right
                    anchors.rightMargin: 16
                }
            },
            State {
                name: "landscape"
                when: parent && parent.width > parent.height
                PropertyChanges {
                    target: root
                    height: constants.headerDefaultHeightInLandscape
                }
            }
        ]
    }
}
