﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import TwitterCore 1.0
import QtWebKit 1.0
import '../Components'

Page {
    id: root

    /* Авторизация
    QWebElement document = webView->page()->mainFrame()->documentElement();
    QWebElement emailTextInput = document.findFirst("input[type=text]");
    emailTextInput.setAttribute("value", loginVars.login);
    QWebElement passTextInput = document.findFirst("input[type=password]");
    passTextInput.setAttribute("value", loginVars.pass);
    document.evaluateJavaScript("login()");*/

    Connections {
        target: oauth
        onOpenAuthPage: {
            brow.url = url;
            console.log("Open this url = "+url)
        }
    }

    signal back

    BusyIndicator {
        id: busyIndicator
        z: 1
        anchors.centerIn: parent
        visible: false
        running: false
        platformStyle: BusyIndicatorStyle { size: "large" }
    }

    tools: ToolBarLayout {
        id: toolBar
        ToolIcon {
            platformIconId: "toolbar-back"
            onClicked: {
                oauth.unauthorize();
                pageStack.pop()
            }
        }

        ToolIcon {
            platformIconId: "toolbar-refresh"
            onClicked: {
                brow.stop.trigger();
                oauth.unauthorize();
                oauth.request_token("http://webpointstudio.ru/auth_success");
            }
        }
    }

    Flickable {
        id: flickableBrowser
        /*anchors.top: header.bottom
        width: parent.width
        height: parent.height*/
        anchors {
            left: parent.left
            right: parent.right
            top: parent.top
            bottom: parent.bottom
        }
        contentWidth: root.width;//brow.contentsSize.width
        contentHeight: Math.max(brow.contentsSize.height, root.height)
        //pressDelay: 200

        WebView {
            id: brow
            anchors.fill: parent
            preferredHeight: parent.height
            preferredWidth: parent.width
            url: ""

            onUrlChanged: {
                function parse_url(url){
                    if (url.indexOf('http://webpointstudio.ru/auth_success?') === 0){
                        url = url.replace('http://webpointstudio.ru/auth_success?','');
                        url = url.match(/oauth_verifier=([^& ]+)/i);
                        var res = RegExp.$1;
/*url = url.split("&");
                        var link = new Array();
                        var pair;
                        var res;
                        for (pair in url){
                            pair=url[pair].split('=');
                            link[pair[0]]=pair[1];
                            if(link[pair[0]] === "oauth_verifier")
                                res = pair[1];
                        }*/
                        return res;
                    } else {
                        return false;
                    }
                }

                if (brow.url.toString().indexOf("auth_success") !== -1)
                {
                    brow.visible = false;
                    oauth.access_token(parse_url(brow.url.toString()));
                    //stop.trigger();
                }
                //TODO: Сделать проверку на отказ от авторизации
                //http://webpointstudio.ru/auth_success?denied=EI922yHbo2F5kX4dZE6NRSDGA3rHFPqsLnE8hjHObc
                console.log("onUrlChanged = " + brow.url);
            }

            onLoadStarted: {
                busyIndicator.visible = true;
                busyIndicator.running = true;
            }

            onLoadFailed: {
                busyIndicator.running = false;
                busyIndicator.visible = false;
            }

            onLoadFinished: {
                busyIndicator.running = false;
                busyIndicator.visible = false;
            }
        }
    }

    /*Column {
        anchors.top: header.bottom
        anchors.horizontalCenter: parent.horizontalCenter
        anchors.margins: 20
        spacing: 20
        Button {
            id: start
            text: qsTr('1. Start')
            enabled: false
            onClicked: oauth.request_token("http://webpointstudio.ru/auth_success")
        }
        TextField {
            id: pin
            width: start.width
            placeholderText: qsTr('2. Enter 7 digits pin code')
            enabled: false
            inputMask: '0000000'
            inputMethodHints: Qt.ImhDigitsOnly | Qt.ImhNoPredictiveText
            platformSipAttributes: SipAttributes {
                actionKeyLabel: qsTr('OK')
                actionKeyEnabled: authorize.enabled
            }
            Keys.onReturnPressed: oauth.access_token(pin.text)
        }

        Button {
            id: authorize
            text: qsTr('3. Authorize')
            enabled: false
            onClicked: oauth.access_token(pin.text)
        }

        Button {
            id: cancel
            text: qsTr('Cancel')
            enabled: true
            onClicked: {
                pin.text = ''
                oauth.unauthorize()
            }
        }
    }*/

    Timer {
        running: state == 'RequestTokenReceived'
        interval: 10
        repeat: false
        onTriggered: oauth.authorize()
    }

    states: [
        State {
            name: "Unauthorized"
            when: oauth.state === OAuth.Unauthorized
            /*PropertyChanges {
                target: start
                enabled: true
            }
            PropertyChanges {
                target: cancel
                enabled: true
            }*/
        },
        State {
            name: "ObtainUnauthorizedRequestToken"
            when: oauth.state === OAuth.ObtainUnauthorizedRequestToken
            /*PropertyChanges {
                target: header
                busy: true
            }*/
        },
        State {
            name: "RequestTokenReceived"
            when: oauth.state === OAuth.RequestTokenReceived
            /*PropertyChanges {
                target: header
                busy: true
            }*/
        },
        State {
            name: "InputVerifier"
            when: oauth.state === OAuth.UserAuthorizesRequestToken && pin.text.length != 7
            /*PropertyChanges {
                target: pin
                enabled: true
            }
            PropertyChanges {
                target: cancel
                enabled: true
            }
            StateChangeScript {
                script: pin.forceActiveFocus()
            }*/
        },
        State {
            name: "UserAuthorizesRequestToken"
            when: oauth.state === OAuth.UserAuthorizesRequestToken && pin.text.length == 7
            /*PropertyChanges {
                target: pin
                enabled: true
            }
            PropertyChanges {
                target: authorize
                enabled: true
            }
            PropertyChanges {
                target: cancel
                enabled: true
            }*/
        },
        State {
            name: "ExchangeRequestTokenForAccessToken"
            when: oauth.state === OAuth.ExchangeRequestTokenForAccessToken
            /*PropertyChanges {
                target: header
                busy: true
            }*/
        },
        State {
            name: "Authorized"
            when: oauth.state === OAuth.Authorized
            StateChangeScript {
                script: {
                    pageStack.push(mainPage);
                }
            }
        }
    ]
}
