﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import TwitterCore 1.0
//import Qt.labs.shaders 1.0
import '../Views'
import '../Delegates'
import '../Components'

AbstractLinkPage {
    id: root

    property alias id_str: direct_message.id_str

    DirectMessage {
        id: direct_message
        onId_strChanged: {
            if (id_str.length == 0 && root.status == PageStatus.Active)
                pageStack.pop()
        }
    }

    TitleBar {
        id: header
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top

        busy: direct_message.loading
    }

    DirectMessageDetailDelegate {
        id: delegate
        anchors.top: header.bottom
        anchors.left: parent.left
        anchors.right: parent.right
        item: direct_message
        sender: direct_message.sender
        recipient: direct_message.recipient
            onLinkActivated: root.openLink(link)
            onUserClicked: pageStack.push(userPage, {'id_str': user.id_str})

        Behavior on height {
            NumberAnimation {}
        }
    }

    Menu {
        id: menu
        visualParent: root.pageStack
        MenuLayout {
            MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-delete'.concat(theme.inverted ? "-white" : "")
                text: qsTr('Delete')
                onClicked: direct_message.destroyDirectMessage()
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            enabled: (pageStack !== null) && pageStack.depth > 1
            onClicked: pageStack.pop()
        }
        /*ToolIcon {
            platformIconId: "toolbar-home"
            enabled: pageStack && pageStack.depth > 1
            onClicked: pageStack.pop(mainPage)
        }

        ToolSpacer {}*/

        ToolIcon {
            platformIconId: "toolbar-reply"
            onClicked: pageStack.push(sendDirectMessagePage, {to: (direct_message.recipient_id == oauth.user_id ? direct_message.sender : direct_message.recipient)})
        }

        /*ToolSpacer {}*/

        ToolIcon {
            platformIconId: "toolbar-view-menu"
            opacity: enabled ? 1.0 : 0.5
            onClicked: {
                if (menu.status == DialogStatus.Closed)
                    menu.open()
                else
                    menu.close()
            }
        }
    }
}
