﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import com.nokia.extras 1.0
import TwitterCore 1.0
//import Qt.labs.shaders 1.0
import Rocket 1.0
import '../Views'
import '../Components'

Page {
    id: mainPg

    Connections {
        target: qDBusServer
        onOpenUriChanged: {
            parseParams();
        }
    }

    function parseParams() {
        var url = [ qDBusServer.openUri ];
        console.log("This is url = " + url);
        for (var i = 0; i < url.length; i++) {
            var arr = url[i].split('/')
            if (arr.shift() !== 'rocket:') continue
            arr.shift()
            var action = arr.shift()
            var parameters = arr
            console.log('action', action)
            if (action === 'page') {
                if (parameters[0] === 'mentions') {
                    tabGroup.currentTab = home;
                    btnMentions.checked = true
                    btnMentions.clicked();
                    tabGroup.currentTab = mentions;
                    //mentions.moveToTop()
                } else if (parameters[0] === 'messages') {
                    btnDirectMessage.checked = true
                    btnDirectMessage.clicked()
                    //directMessage.moveToTop()
                } else {
                    console.debug('unknown parameters', parameters)
                }
            } else if (action === 'status') {
                var statusId = ''+url;
                statusId = statusId.replace(/rocket:\/\/status\//g, '');
                pageStack.push(statusPage, {'id_str': statusId})
            } else if (action === 'directmessage') {
                pageStack.push(directMessagePage, {'id_str': parameters[0]})
            } else if (action === 'user') {
                pageStack.push(userPage, {'id_str': parameters[0]})
            } else if (action === 'screen_name') {
                pageStack.push(userPage, {'screen_name': parameters[0]})
            } else if (action === 'newtweet') {
                var tweetText = ''+url;
                tweetText = tweetText.replace(/rocket:\/\/newtweet\//g, '');
                pageStack.push(tweetPage, {'statusText': tweetText})
            } else if (action === 'newtweet_with_image') {
                var tweetImage = ''+url;
                tweetImage = tweetImage.replace(/rocket:\/\/newtweet_with_image\//g, '');
                mediaSelected = 'image://rocket/'+tweetImage;
                pageStack.push(tweetPage, {'currentAction': 'gallery'})
            }
        }
    }

    /*function changeTabsToLeft()
    {
        if (tabGroup.currentTab === home)
            tabGroup.currentTab = savedSearches
        else if (tabGroup.currentTab === mentions)
            tabGroup.currentTab = home
        else if (tabGroup.currentTab === directMessage)
            tabGroup.currentTab = mentions
        else if (tabGroup.currentTab === savedSearches)
            tabGroup.currentTab = directMessage
    }

    function changeTabsToRight()
    {
        if (tabGroup.currentTab === home)
            tabGroup.currentTab = mentions
        else if (tabGroup.currentTab === mentions)
            tabGroup.currentTab = directMessage
        else if (tabGroup.currentTab === directMessage)
            tabGroup.currentTab = savedSearches
        else if (tabGroup.currentTab === savedSearches)
            tabGroup.currentTab = home
    }*/

    Timer {
        running: mainPg.status == PageStatus.Active && oauth.state !== OAuth.Authorized
        interval: 100
        onTriggered: {
            pageStack.push(welcomePage);
            /*oauth.request_token();
            pageStack.push(authorizationPage);*/
        }
    }

    TabGroup {
        id: tabGroup
        //x: sideBar.width;
        anchors.fill: parent

        currentTab: home

        property bool active: mainPg.status === PageStatus.Active &&  platformWindow.viewMode === WindowState.Fullsize && platformWindow.visible && platformWindow.active
        HomePage { id: home; pageStack: mainPg.pageStack; active: tabGroup.currentTab == home && tabGroup.active; visible: tabGroup.currentTab == home; }
        MentionsPage { id: mentions; pageStack: mainPg.pageStack; active: tabGroup.currentTab == mentions && tabGroup.active; visible: tabGroup.currentTab == mentions; }
        DirectMessagesPage { id: directMessage; pageStack: mainPg.pageStack; active: tabGroup.currentTab == directMessage && tabGroup.active; visible: tabGroup.currentTab == directMessage; }
        SavedSearchStreamPage { id: savedSearches; pageStack: mainPg.pageStack; active: tabGroup.currentTab == savedSearches && tabGroup.active; visible: tabGroup.currentTab == savedSearches; }

        Connections {
            target: tabGroup
            onCurrentTabChanged: {
                if (menu.status !== DialogStatus.Closed)
                    menu.close()
            }
        }
    }

    Menu {
        id: menu
        visualParent: mainPg.pageStack
        MenuLayout {
            /*MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-search'.concat(theme.inverted ? "-white" : "")
                text: qsTr('New search')
                onClicked: pageStack.push(newSearchPage)
            }*/

            MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-list'.concat(theme.inverted ? "-white" : "")
                text: qsTr('Lists')
                onClicked: pageStack.push(listsPage, {id_str: oauth.user_id, title: 'Lists'})
            }

            MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-favorite-mark'.concat(theme.inverted ? "-white" : "")
                text: qsTr('Favorites')
                onClicked: pageStack.push(favouritesPage, {id_str: oauth.user_id, screen_name: oauth.screen_name})
            }

            /*MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-search'.concat(theme.inverted ? "-white" : "")
                Image {
                    width: 24
                    height: 24
                    smooth: true
                    source: 'image://theme/icon-m-toolbar-favorite-mark'.concat(theme.inverted ? "-white" : "")
                    anchors.top: parent.top
                    anchors.right: parent.right
                    anchors.topMargin: 25
                    anchors.rightMargin: 34
                }
                text: qsTr('Saved Searches')
                onClicked: pageStack.push(savedSearchesPage)
            }*/
            MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-contact'.concat(theme.inverted ? "-white" : "")
                text: qsTr('Account')
                onClicked: pageStack.push(accountPage)
            }
            MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-volume-off'.concat(theme.inverted ? "-white" : "")
                text: qsTr('Mute Filters')
                onClicked: pageStack.push(mutePage)
            }
            MenuItemWithIcon {
                iconSource: 'image://theme/icon-m-toolbar-settings'.concat(theme.inverted ? "-white" : "")
                text: qsTr('Settings')
                onClicked: pageStack.push(settingsPage)
            }
            MenuItemWithIcon {
                //iconSource: 'image://theme/icon-m-toolbar-new-email'.concat(theme.inverted ? "-white" : "")
                text: qsTr('About')
                onClicked: pageStack.push(aboutPage)
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout
        visible: true
        //x: sideBar.width;

        ButtonRow {
            TabButton {
                id: homeButton
                iconSource: theme.inverted ? '../images/home-white.png' : '../images/home.png'
                tab: home

                CountBubble {
                    id: timelineCounter
                    anchors.top: parent.top
                    anchors.right: parent.right
                    anchors.topMargin: -5
                    value: home.unreadCount
                    largeSized: true
                    scale: value > 0 && !loadedTimer.running ? 1.0 : 0.0
                    visible: scale > 0
                    //Behavior on scale { NumberAnimation{duration: 1000; easing.type: Easing.OutElastic} }
                }

                Rectangle {
                    anchors.bottom: parent.bottom
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    anchors.right: parent.right
                    anchors.rightMargin: 1
                    height: 4
                    color: "#1082de"
                    visible: home.unreadCount > 0 && !loadedTimer.running ? 1.0 : 0.0
                }
            }

            TabButton {
                id: btnMentions
                iconSource: theme.inverted ? '../images/mentions-white.png' : '../images/mentions.png'
                tab: mentions
                CountBubble {
                    anchors.top: parent.top
                    anchors.right: parent.right
                    anchors.topMargin: -5
                    value: mentions.unreadCount
                    largeSized: true
                    scale: value > 0 && btnMentions.enabled ? 1.0 : 0.0
                    visible: scale > 0
                    //Behavior on scale { NumberAnimation{duration: 1000; easing.type: Easing.OutElastic} }
                }

                Rectangle {
                    anchors.bottom: parent.bottom
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    anchors.right: parent.right
                    anchors.rightMargin: 1
                    height: 4
                    color: "#1082de"
                    visible: mentions.unreadCount > 0 && btnMentions.enabled ? 1.0 : 0.0
                }
            }
            TabButton {
                id: btnDirectMessage
                iconSource: theme.inverted ? '../images/dm-white.png' : '../images/dm.png'
                tab: directMessage
                CountBubble {
                    anchors.top: parent.top
                    anchors.right: parent.right
                    anchors.topMargin: -5
                    value: directMessage.unreadCount
                    largeSized: true
                    scale: value > 0 && btnDirectMessage.enabled ? 1.0 : 0.0
                    visible: scale > 0
                    //Behavior on scale { NumberAnimation{duration: 1000; easing.type: Easing.OutElastic} }
                }

                Rectangle {
                    anchors.bottom: parent.bottom
                    anchors.left: parent.left
                    anchors.leftMargin: 1
                    anchors.right: parent.right
                    anchors.rightMargin: 1
                    height: 4
                    color: "#1082de"
                    visible: directMessage.unreadCount > 0 && btnDirectMessage.enabled ? 1.0 : 0.0
                }
            }
            TabButton {
                iconSource: theme.inverted ? '../images/search-white.png' : '../images/search.png'
                tab: savedSearches
            }
        }
        ToolIcon {
            platformIconId: "toolbar-view-menu"
            opacity: enabled ? 1.0 : 0.5
            onClicked: {
                if (menu.status == DialogStatus.Closed)
                    menu.open()
                else
                    menu.close()
            }
        }
    }
}
