﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import QtWebKit 1.0
import '../Components'

Page {
    id: root

    property double _lat
    property double _long
    property string title

    property int mapsService

    TitleBar {
        id: header
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top

        text: qsTr('View Map')
        busy: map.loading
    }

    WebView {
        id: map
        anchors.topMargin: header.height
        anchors.fill: parent
        preferredWidth: (screen.currentOrientation === Screen.Portrait) ? parent.width : parent.width
        preferredHeight: (screen.currentOrientation === Screen.Portrait) ? parent.height - header.height : parent.height - header.height
        url: {
            if (mapsService == 0)
                return 'qrc:/qml/rocket/Pages/NokiaMaps.html'
            else
                return 'qrc:/qml/rocket/Pages/GoogleMaps.html'
        }

        property bool loading: false
        onLoadStarted: loading = true
        onLoadFinished: {
            loading = false
            evaluateJavaScript('update()')
        }
        onAlert: console.debug('alert:', message)

        javaScriptWindowObjects: QtObject {
            id: js
            WebView.windowObjectName: "qml"
            property real lat: root._lat
            property real lng: root._long
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            onClicked: pageStack.pop()
        }
        ToolIcon {
            iconSource: theme.inverted ? '../images/plus-white.png' : '../images/plus.png'
            onClicked: map.evaluateJavaScript('zoomIn()')
        }
        ToolIcon {
            iconSource: theme.inverted ? '../images/minus-white.png' : '../images/minus.png'
            onClicked: map.evaluateJavaScript('zoomOut()')
        }
        ToolIcon {
            //platformIconId: "toolbar-back"
            //onClicked: map.evaluateJavaScript('zoomOut()')
            enabled: false
        }
    }
}
