﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import TwitterCore 1.0
import TwitterCore.extra 1.0
import '../Components'
import '../Views'

AbstractLinkPage {
    id: root

    //onHeaderClicked: if (!model.loading) view.positionViewAtBeginning()

    property bool active: false
    property string __maxReadIdStr: settings.readData('SavedSearchStreamPage/maxReadIdStr', '')
    //property variant topData: model.get(view.topItemIndex)
    //onTopDataChanged: refresh.toBeRefreshed = true
    property int unreadCount: 0

    //busy: trendsModel.loading

    Settings {
        id: netSettings
        onLoadingChanged: {
            if (!loading) {
                if (netSettings.trend_location.length > 0) {
                    trendsModel.woeid = netSettings.trend_location[0].woeid
                }
            }
        }
    }

    TitleBar {
        id: header
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        z: 1
        newtweet: false
        homeButton: false
        TextField {
            id: searchField
            z: 1
            anchors.centerIn: parent
            width: parent.width - (header.height - searchField.height)/2
            placeholderText: qsTr('Search')
            platformStyle: TextFieldStyle { textFont.pixelSize: constants.fontDefault }
			inputMethodHints: Qt.ImhNoAutoUppercase | Qt.ImhNoPredictiveText;
            platformSipAttributes: SipAttributes {
                actionKeyLabel: 'Search'
                actionKeyEnabled: searchField.text != ''
            }
            Keys.onReturnPressed: {
                pageStack.push(searchPage, {'id_str': searchField.text})
            }
        }
    }


    Flickable {
        id: flickableBrowser
        anchors {
            left: parent.left
            right: parent.right
            top: header.bottom
            bottom: parent.bottom
        }
        contentWidth: root.width;//brow.contentsSize.width
        contentHeight: clmComponents.height

        Column {
            id: clmComponents
            width: parent.width
            spacing: 0
            Rectangle {
                id: clmHeader
                width:  parent.width
                height: 40
                color: theme.inverted ? "black" : "#e7e7e7";
                Rectangle {
                    anchors.top: parent.top
                    height: 1
                    width: parent.width
                    color: "#cecbce";
                }
                Label {
                    anchors.left: parent.left
                    anchors.leftMargin: 17
                    anchors.verticalCenter: parent.verticalCenter
                    font.bold: true
                    text: qsTr("Saved Searches")
                }
            }

    SavedSearchListView {
                id: savedSearchView
                anchors.left: parent.left
                anchors.right: parent.right
                interactive: false
        loading: model.loading
        model: savedSearchesModel
                //height: delegate.height * count + 30
                clip: true
                onShowDetail: pageStack.push(searchPage, {'id_str': detail.query})
            }

            Rectangle {
                id: clmHeader2
                width:  parent.width
                height: 40
                color: theme.inverted ? "black" : "#e7e7e7";
                Rectangle {
                    anchors.top: parent.top
                    height: 1
                    width: parent.width
                    color: "#cecbce";
                }
                Label {
                    anchors.left: parent.left
                    anchors.leftMargin: 17
                    anchors.verticalCenter: parent.verticalCenter
                    font.bold: true
                    text: qsTr("Available trends")
                }
            }

            TrendListView {
                id: trendsView
                anchors.left: parent.left
                anchors.right: parent.right
                model: TrendsAvailableModel {
                    id: trendsModel;
                }
                onShowDetail: pageStack.push(searchPage, {'id_str': detail.name})
            }
        }
    }

    tools: ToolBarLayout {
        id: toolBarLayout
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            onClicked: pageStack.pop()
        }
    }
}
