﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import TwitterCore 1.0
import '../Components'
import '../Views'

Page {
    id: root

    TitleBar {
        id: header
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        text: qsTr('Search')
        busy: model.loading
    }

    TextField {
        id: searchField
        anchors.top: header.bottom
        width: parent.width
        placeholderText: qsTr('Search')
        platformStyle: TextFieldStyle { textFont.pixelSize: constants.fontDefault }
        platformSipAttributes: SipAttributes {
            actionKeyLabel: 'Search'
            actionKeyEnabled: searchField.text.length > 0
        }
        Keys.onReturnPressed: {
            //showSuggestions.forceActiveFocus()
            pageStack.push(searchPage, {query: searchField.text})
        }
    }

    Component {
        id: clmHeader
        Rectangle {
            width:  parent.width
            height: 40
            color: "#e7e7e7"
            Rectangle {
                anchors.top: parent.top
                height: 1
                width: parent.width
                color: "#cecbce";
            }
            Label {
                anchors.left: parent.left
                anchors.leftMargin: 17
                anchors.verticalCenter: parent.verticalCenter
                font.bold: true
                text: qsTr("Saved Searches")
            }
        }
    }

    SavedSearchListView {
        anchors { top: searchField.bottom; left: parent.left; right: parent.right; bottom: parent.bottom }
        loading: model.loading
        model: savedSearchesModel
        header: clmHeader
        onShowDetail: pageStack.push(searchPage, {query: detail.query})
    }

    tools: ToolBarLayout {
        id: toolBarLayout
        visible: true
        ToolIcon {
            platformIconId: "toolbar-back"
            onClicked: pageStack.pop()
        }
        /*ToolIcon {
            platformIconId: "toolbar-home"
            onClicked: pageStack.pop(mainPage)
        }
        ToolSpacer {columns: 4}*/
    }
}
