﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import com.nokia.meego 1.0
import '../Components'

Page {
    id: root

    tools: ToolBarLayout {
        id: toolBar
        ToolIcon {
            platformIconId: "toolbar-back"
            onClicked: {
                Qt.quit();
            }
        }
    }

    TitleBar {
        id: header
        z: 1
        anchors.left: parent.left
        anchors.right: parent.right
        anchors.top: parent.top
        homeButton: false
        newtweet: false
        Label {
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            text: "Welcome to Rocket!"
            color: 'white'
            font.bold: false
            font.pixelSize: 32
            platformStyle: LabelStyle {
                textColor: "white"
            }
        }
    }

    Flickable {
        anchors {
            left: parent.left
            right: parent.right
            top: header.bottom
            bottom: parent.bottom
        }
        contentWidth: root.width;
        contentHeight: content.height
        Column {
            id: content
            anchors.top: welcomeText.bottom
            anchors.topMargin: 30
            anchors.left: parent.left
            anchors.leftMargin: 17
            anchors.right: parent.right
            anchors.rightMargin: 17
            spacing: (screen.currentOrientation === Screen.Portrait) ? 12 : 3;

            Image {
                id: logo
                anchors.top: parent.top
                anchors.topMargin: (screen.currentOrientation === Screen.Portrait) ? 12 : 3;
                anchors.horizontalCenter: parent.horizontalCenter
                width: 214
                height: 214
                source: "qrc:/qml/rocket/images/rocket_logo_213.png"
            }

            Label {
                id: welcomeText
                text: "The best way to discover what's new in your world."
                wrapMode: Text.WordWrap
                anchors.horizontalCenter: parent.horizontalCenter
                width: (screen.currentOrientation === Screen.Portrait) ? 446 : 560;
                /*anchors.left: parent.left
                anchors.right: parent.right*/
            }

            Button {
                id: signIn
                text: qsTr('Sign in')
                anchors.horizontalCenter: parent.horizontalCenter
                width: 360//parent.width
                onClicked: {
                    oauth.request_token("http://webpointstudio.ru/auth_success")
                    pageStack.push(authorizationPage)
                }
            }

            Button {
                id: signUp
                text: qsTr('Sign up...')
                anchors.horizontalCenter: parent.horizontalCenter
                width: 360//parent.width
                onClicked: {
                    Qt.openUrlExternally("http://mobile.twitter.com/signup");
                }
            }

            Button {
                id: privacy
                text: qsTr('Privacy Policy')
                anchors.horizontalCenter: parent.horizontalCenter
                width: 360//parent.width
                onClicked: {
                    Qt.openUrlExternally("http://twitter.com/privacy");
                }
            }
        }
    }
}
