/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
.pragma library

var wait = false;

// Common functions
function strpos(haystack, needle){ // Find position of first occurrence of a string
    var i = haystack.indexOf(needle); // returns -1
    return i >= 0 ? i : false;
}

function substr( f_string, f_start, f_length ) {    // Return part of a string
    if(f_start < 0) {
        f_start += f_string.length;
    }
    if(f_length == undefined) {
        f_length = f_string.length;
    } else if(f_length < 0){
        f_length += f_string.length;
    } else {
        f_length += f_start;
    }
    if(f_length < f_start) {
        f_length = f_start;
    }
    return f_string.substring(f_start, f_length);
}

// Flickr photo_id decoder
function base_decode(num) {
    var alphabet = '123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ';
    var decoded = 0;
    var multi = 1;
    while (num.length > 0) {
        var digit = num[num.length-1];
        decoded += multi * strpos(alphabet, digit);
        multi = multi * alphabet.length;
        num = substr(num, 0, -1);
    }
    return decoded;
}

function setTimeout(callback, timeout) {
    var obj = Qt.createQmlObject('import Qt 4.7; Timer {running: false; repeat: false; interval: ' + timeout + '}', this, "setTimeout");
    obj.triggered.connect(callback);
    obj.running = true;

    return obj;
}

//Fixme: Better and original implementation is welcomed!!
function base58_decode( snipcode ) {
    var alphabet = '123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ' ;
    var num = snipcode.length ;
    var decoded = 0 ;
    var multi = 1 ;
    for ( var i = (num-1) ; i >= 0 ; i-- )
    {
        decoded = decoded + multi * alphabet.indexOf( snipcode[i] ) ;
        multi = multi * alphabet.length ;
    }
    return decoded;
}

function getFlickrPhotoUrl(url, callback) {
    var request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader("Content-Type", "text/xml");
    request.onreadystatechange = function() {
        console.debug(request.readyState);
        console.debug(request.status);
        var a = new Array(2)
        if ( request.readyState === XMLHttpRequest.HEADERS_RECEIVED) {
            console.debug(request.getAllResponseHeaders());
        } else if ( request.readyState === XMLHttpRequest.DONE && request.status === 200 ) {
            console.debug(request.responseText);
            var jsonobj = JSON.parse(request.responseText);
            a[0] = jsonobj.sizes.size[5].source;
            a[1] = jsonobj.sizes.size[5].source;
            callback(a);
        }
    }
    request.send();
}

function getViaMePhotoUrl(url, callback) {
    var request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader("Content-Type", "application/json");
    request.onreadystatechange = function() {
        var a = new Array(2)
        if ( request.readyState === XMLHttpRequest.DONE ) {
            if ( request.status === 200 ) {
                var resp = request.responseText;
                console.debug(resp);
                var jsonobj = JSON.parse(resp);
                a[0] = jsonobj.response.post.thumb_600_url;
                a[1] = jsonobj.response.post.media_url;
                callback(a);
            }
        }
    }
    request.send();
}

function getVimeoUrl(url, callback) {
    var request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader("Content-Type", "application/json");
    request.onreadystatechange = function() {
        var a = new Array(2)
        if ( request.readyState === XMLHttpRequest.DONE ) {
            if ( request.status === 200 ) {
                var resp = request.responseText;
                console.debug(resp);
                var jsonobj = JSON.parse(resp);
                a[0] = jsonobj[0].thumbnail_large;
                a[1] = jsonobj[0].thumbnail_large;
                callback(a);
            }
        }
    }
    request.send();
}

function getImgurPhotoUrl(url, callback) {
    var request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader("Content-Type", "application/json");
    request.onreadystatechange = function() {
        var a = new Array(2)
        if ( request.readyState === XMLHttpRequest.DONE )
            if( request.status === 200 ) {
                var jsonobj = JSON.parse(request.responseText);
                a[0] = jsonobj.image.links.large_thumbnail;
                a[1] = jsonobj.image.links.original;
                callback(a);
            }
    }
    request.send();
}

function getPosterousPhotoUrl(url, callback) {
    var request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader("Content-Type", "text/xml");
    request.onreadystatechange = function() {
        var a = new Array(2)
        if ( request.readyState === XMLHttpRequest.DONE ) {
            if ( request.status === 200 ) {
                var xml = request.responseXML.documentElement
                var rootNode = xml.childNodes[1].childNodes[19]
                var nodeLength = rootNode.childNodes.length

                a[0] = rootNode.childNodes[3].childNodes[1].childNodes[0].nodeValue;
                a[1] = rootNode.childNodes[3].childNodes[1].childNodes[0].nodeValue;
                callback(a);
            }
        }
    }
    request.send();
}

function getCllyPhotoUrl(url, callback) {
    var request = new XMLHttpRequest();
    request.open('GET', url);
    request.setRequestHeader("Content-Type", "application/json");
    request.setRequestHeader("Accept", "application/json");
    request.onreadystatechange = function() {
        var a = new Array(2)
        if ( request.readyState === XMLHttpRequest.DONE )
            if( request.status === 200 ) {
                var jsonobj = JSON.parse(request.responseText);
                a[0] = jsonobj.remote_url;
                a[1] = jsonobj.remote_url;
                callback(a);
            }
    }
    request.send();
}

function load(url) {
    return true;
}

function parse(text, callback) {
    var ret = []

    var href = new RegExp(/<a class=".*?" href="https?:\/\/(.+?)"/g);
    var arr;
    while ((arr = href.exec(text)) !== null) {
        var link = arr[1];
        if (link.match(/twitpic\.com\/([^\/ ]+)/)) {
            ret.push({'thumbnail': 'http://twitpic.com/show/large/'.concat(RegExp.$1), 'media': 'http://twitpic.com/show/large/'.concat(RegExp.$1)})
            callback(ret);
        }
        else if (link.match(/yfrog\.com\/([^\/ ]+)/)) {
            ret.push({'thumbnail': 'http://yfrog.com/'.concat(RegExp.$1).concat(':medium'), 'media': 'http://yfrog.com/'.concat(RegExp.$1).concat(':medium')})
            callback(ret);
        }
        else if (link.match(/movapic\.com\/([^\/ ]+)/)) {
            ret.push({'thumbnail': 'http://image.movpic.com/pic/t_'.concat(RegExp.$1).concat('.jpeg'), 'media': 'http://image.movpic.com/pic/t_'.concat(RegExp.$1).concat('.jpeg')})
            callback(ret);
        }
        else if (link.match(/molo\.me\/p\/([^\/ ]+)/)) {
            ret.push({'thumbnail': 'http://p480x480.molo.me/'.concat(RegExp.$1).concat('_480x480'), 'media': 'http://p.molo.me/'.concat(RegExp.$1)})
            callback(ret);
        }
        else if (link.match(/youtube\.com\/watch\?v=([^\/ ]+)/)) {
            var parameters = link.split('?')
            parameters.shift()
            parameters = parameters.join('?').split('&')
            var videoId;
            for (var i = 0; i < parameters.length; i++) {
                if (parameters[i].substring(0, 2) === 'v=') {
                    videoId = parameters[i].substring(2)
                    console.debug(videoId)
                    console.log('http://img.youtube.com/vi/'.concat(videoId).concat('/0.jpg'))
                    break
                }
            }
            ret.push({'thumbnail': 'http://img.youtube.com/vi/'.concat(videoId).concat('/0.jpg'), 'media': 'http://img.youtube.com/vi/'.concat(videoId).concat('/0.jpg')})
            callback(ret);
        }
        else if (link.match(/youtu\.be\/([^\/? ]+)/)) {
            ret.push({'thumbnail': 'http://img.youtube.com/vi/'.concat(RegExp.$1).concat('/0.jpg'), 'media': 'http://img.youtube.com/vi/'.concat(RegExp.$1).concat('/0.jpg')})
            callback(ret);
        }
        else if (link.match(/picplz\.com\/([^\/ ]+)/)) {
            ret.push({'thumbnail': 'http://picplz.com/'.concat(RegExp.$1).concat('/thumb/400'), 'media': 'http://picplz.com/'.concat(RegExp.$1).concat('/thumb/400')})
            callback(ret);
        }
        else if (link.match(/instagr\.am\/p\/([^\/ ]+)\//)) {
            ret.push({'thumbnail': 'http://instagr.am/p/'.concat(RegExp.$1).concat('/media/?size=l'), 'media': 'http://instagr.am/p/'.concat(RegExp.$1).concat('/media/?size=l')})
            callback(ret);
        }
        else if (link.match(/instagram\.com\/p\/([^\/ ]+)\//)) {
            ret.push({'thumbnail': 'http://instagram.com/p/'.concat(RegExp.$1).concat('/media/?size=l'), 'media': 'http://instagram.com/p/'.concat(RegExp.$1).concat('/media/?size=l')})
            callback(ret);
        }
        else if (link.match(/lockerz\.com\/s\/([^\/ ]+)/)) {
            var id = link.substring('lockerz.com/s/'.length)
            ret.push({'thumbnail': 'http://api.plixi.com/api/tpapi.svc/imagefromurl?size=medium&url='.concat('http://'+link), 'media': 'http://api.plixi.com/api/tpapi.svc/imagefromurl?size=medium&url='.concat('http://'+link)})
            callback(ret);
        }
        else if (link.match(/img.\ly\/([^\/ ]+)/)) {
            var imglyId = link.substring('img.ly/'.length)
            ret.push({'thumbnail': 'http://img.ly/show/full/'.concat(imglyId), 'media': 'http://img.ly/show/full/'.concat(imglyId)})
            callback(ret);
        }
        else if (link.match(/twitgoo\.com\/([^\/ ]+)/))
        {
            var twitgooId = link.substring('twitgoo.com/'.length)
            ret.push({'thumbnail': 'http://twitgoo.com/show/img/'.concat(twitgooId), 'media': 'http://twitgoo.com/show/img/'.concat(twitgooId)})
            callback(ret);
        }
        else if (link.match(/post\.ly\/([^\/ ]+)/))
        {
            var postlyId = link.substring('post.ly/'.length)
            getPosterousPhotoUrl('http://posterous.com/api/getpost?id=%1'.arg(postlyId), function(ret) {
                ret.push({'thumbnail': ret[0], 'media': ret[1]})
                callback(ret);
            });
        }
        /*else if (link.match(/cl\.ly\/([^\/ ]+)/))
        {
            //Content-Type: application/json
            var cllyId = link.substring('cl.ly/'.length)
            getCllyPhotoUrl('http://cl.ly/%1'.arg(cllyId), function(ret) {
                ret.push({'thumbnail': ret[0], 'media': ret[1]})
                callback(ret);
            });
        }*/
        else if (link.match(/moby\.to\/([^\/ ]+)/))
        {
            var mobytoId = link.substring('moby.to/'.length)
            ret.push({'thumbnail': 'http://moby.to/'.concat(mobytoId).concat(':view'), 'media': 'http://moby.to/'.concat(mobytoId).concat(':full') })
            callback(ret);
        }
        else if (link.match(/twitrpix\.com\/([^\/ ]+)/))
        {
            var twitrpixId = link.substring('twitrpix.com/'.length)
            ret.push({'thumbnail': 'http://img.twitrpix.com/'.concat(twitrpixId), 'media': 'http://img.twitrpix.com/'.concat(twitrpixId) })
            callback(ret);
        }
        else if (link.match(/p\.twipple\.jp\/([^\/ ]+)/))
        {
            var twippleId = link.substring('p.twipple.jp/'.length)
            ret.push({'thumbnail': 'http://p.twpl.jp/show/orig/'.concat(twippleId), 'media': 'http://p.twpl.jp/show/orig/'.concat(twippleId) })
            callback(ret);
        }
        else if (link.match(/p\.twpl\.jp\/([^\/ ]+)/))
        {
            var twipple2Id = link.substring('p.twpl.jp/'.length)
            ret.push({'thumbnail': 'http://p.twpl.jp/show/orig/'.concat(twipple2Id), 'media': 'http://p.twpl.jp/show/orig/'.concat(twipple2Id) })
            callback(ret);
        }
        else if (link.match(/screentweet\.com\/([^\/ ]+)/))
        {
            var screentweetId = link.substring('screentweet.com/'.length)
            ret.push({'thumbnail': 'http://screentweet.com/st/'.concat(screentweetId).concat('/tn_full.jpg'), 'media': 'http://screentweet.com/st/'.concat(screentweetId).concat('/tn_full.jpg') })
            callback(ret);
        }
        else if (link.match(/scr\.tw\/([^\/ ]+)/))
        {
            var screentweetId2 = link.substring('scr.tw/'.length)
            ret.push({'thumbnail': 'http://screentweet.com/st/'.concat(screentweetId2).concat('/tn_full.jpg'), 'media': 'http://screentweet.com/st/'.concat(screentweetId2).concat('/tn_full.jpg') })
            callback(ret);
        }
        else if (link.match(/pk\.gd\/([^\/ ]+)/))
        {
            var pkgdId = link.substring('pk.gd/'.length)
            ret.push({'thumbnail': 'http://img.pikchur.com/pic_'.concat(pkgdId).concat('_m.jpg'), 'media': 'http://img.pikchur.com/pic_'.concat(pkgdId).concat('_l.jpg') })
            callback(ret);
        }
        else if (link.match(/pikchur\.com\/([^\/ ]+)/))
        {
            var pikchurId = link.substring('pikchur.com/'.length)
            ret.push({'thumbnail': 'http://img.pikchur.com/pic_'.concat(pikchurId).concat('_m.jpg'), 'media': 'http://img.pikchur.com/pic_'.concat(pikchurId).concat('_l.jpg') })
            callback(ret);
        }
        else if (link.match(/campl.us\/([^\/ ]+)/))
        {
            var camplusId = link.substring('campl.us/'.length)
            ret.push({'thumbnail': 'http://campl.us/%1:480px'.arg(camplusId), 'media': 'http://campl.us/%1:800px'.arg(camplusId)})
            callback(ret);
        }
        else if (link.match(/camerapl.us\/([^\/ ]+)/))
        {
            var camplusId2 = link.substring('camerapl.us/'.length)
            ret.push({'thumbnail': 'http://camerapl.us/%1:480px'.arg(camplusId2), 'media': 'http://camerapl.us/%1:800px'.arg(camplusId2)})
            callback(ret);
        }
        else if (link.match(/9gag\.com\/gag\/([^\/? ]+)/))
        {
            var gagId = link.substring('9gag.com/gag/'.length)
            ret.push({'thumbnail': 'http://d24w6bsrhbeh9d.cloudfront.net/photo/'.concat(gagId).concat('_460s.jpg'), 'media': 'http://d24w6bsrhbeh9d.cloudfront.net/photo/'.concat(gagId).concat('_700b.jpg')})
            callback(ret);
        }
        else if (link.match(/i.imgur\.com\/([^\/? ]+)/))
        {
            var imgurId = link.substring('i.imgur.com/'.length)
            ret.push({'thumbnail': 'http://i.imgur.com/'.concat(imgurId.replace(/\./, 'l.')), 'media': 'http://'.concat(link)})
            callback(ret);
        }
        else if (link.match(/imgur\.com\/gallery\/([^\/? ]+)/))
        {
            id = link.substring('imgur.com/gallery/'.length)
            getImgurPhotoUrl('http://api.imgur.com/2/image/%1.json'.arg(id), function(ret) {
                ret.push({'thumbnail': ret[0], 'media': ret[1]})
                callback(ret);
            });
        }
        else if (link.match(/via\.me\/([^\/? ]+)/))
        {
            var clientId = '4528nhujgukloc25pg0dqg74d';
            var viaMeId = link.substring('via.me/-'.length);
            var apiurl = 'http://api.via.me/v1/posts/'.concat(viaMeId).concat('?client_id=').concat(clientId);
            getViaMePhotoUrl(apiurl, function(ret) {
                ret.push({'thumbnail': ret[0], 'media': ret[1]})
                callback(ret);
            });
        }
        else if (link.match(/vimeo\.com\/([^\/? ]+)/))
        {
            var vimeoId = link.substring('vimeo.com/'.length);
            var vimeoApiUrl = 'http://vimeo.com/api/v2/video/'.concat(vimeoId).concat('.json');
            getVimeoUrl(vimeoApiUrl, function(ret) {
                ret.push({'thumbnail': ret[0], 'media': ret[1]})
                callback(ret);
            });
        }
        else if (link.match(/p\.twimg\.com\/([^\/? ]+)/))
        {
            ret.push({'thumbnail': 'http://'.concat(link), 'media': 'http://'.concat(link)})
            callback(ret);
        }
        else if (link.match(/sdrv.ms\/([^\/ ]+)/))
        {
            ret.push({'thumbnail': 'https://apis.live.net/v5.0/skydrive/get_item_preview?type=normal&url=http://'.concat(link), 'media': 'https://apis.live.net/v5.0/skydrive/get_item_preview?type=normal&url=http://'.concat(link)})
            callback(ret);
        }
        else if (link.match(/irafa\.ru\/hg\/?([^\/ ]+)/))
        {
            var hotGirlsId = link.substring('irafa.ru/hg/?'.length);
            ret.push({'thumbnail': 'http://irafa.ru/projectpron/images/'.concat(hotGirlsId).concat('.jpg'), 'media': 'http://irafa.ru/projectpron/images/'.concat(hotGirlsId).concat('.jpg')})
            callback(ret);
        }
        else if (link.match(/flic\.kr\/p\/([^\/ ]+)/)) {
            var url = link;
            var id = '';
            var phototype = '';
            var apiurl = '';
            var apikey = 'a7cefa56cc7a245f4d72252acc51aa5d';

            console.debug("Source URL is ".concat(url));
            var a = url.split('/'); a.shift() // domainname
            phototype = a.shift(); // p or ps
            // phototype 'ps' is PhotoStream, not photo.
            if (phototype === 'p') {
                console.log("phototype === 'p'");
                id = base58_decode(url.substring('flic.kr/p/'.length));
                console.debug("Photo ID is " + id);
                apiurl = 'http://api.flickr.com/services/rest/?method=flickr.photos.getSizes&api_key='.concat(apikey).concat('&format=json&nojsoncallback=1&photo_id=').concat(id);
                if (getFlickrPhotoUrl(apiurl, function(ret) {
                    ret.push({'thumbnail': ret[0], 'media': ret[1]});
                    callback(ret);
                }));
            } else {
                return false
            }
        }
        else if (link.match(/[0-9a-zA-Z]([-.\w]*[0-9a-zA-Z])*(:(0-9)*)*(\/)([a-zA-Z0-9\-\.\?\,\'\/\\\+&%\$#_]*)(\/.*)(\.jpg|\.jpeg|\.png|\.bmp|\.gif)/))
        {
            ret.push({'thumbnail': 'http://'+link, 'media': 'http://'+link})
            callback(ret);
        }
        /*
          500px
          https://api.500px.com/v1/photos/1377621?consumer_key=taRiBgRIy5e979FMjavlwCQKkFgjB0zlFwJtgbNk
          Photo Id: 1377621
          Consumer Key: taRiBgRIy5e979FMjavlwCQKkFgjB0zlFwJtgbNk
          Get: image_url
        */
        //http://flic.kr/p/bnJS3D
    }
}
