﻿/* © Webpoint Studio, 2008-2013
 *
 * Site:   http://webpointstudio.ru
 * E-mail: info@webpointstudio.ru
 */

/* Copyright (c) 2012 QNeptunea Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of the QNeptunea nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL QNEPTUNEA BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
import QtQuick 1.1
import QtMobility.systeminfo 1.2
import QtMobility.feedback 1.1
//import Qt.labs.shaders 1.0
import com.nokia.meego 1.0
import com.nokia.extras 1.1
import TwitterCore 1.0
import Rocket 1.0
import 'Pages'
import 'Components'
import 'Services'

PageStackWindow {
    id: window
    showToolBar: true

    /*Item {
        id: sideBar
        anchors.left: parent.left
        anchors.top: parent.top
        anchors.bottom: parent.bottom
        width: 0
        onWidthChanged: SequentialAnimation {
            NumberAnimation {
                target: sideBar;
                property: "width";
                from: sideBar.width == 0 ? 0 : 400;
                to: sideBar.width == 0 ? 400 : 0;
            }
        }

        Flickable {
            id: container
            anchors.fill: parent
            contentHeight: profilePane.height
            clip: true
            Column {
                id: profilePane
                anchors.top: parent.top
                anchors.topMargin: 17
                anchors.left: parent.left
                anchors.leftMargin: 17
                width: parent.width
                spacing: 4

                Item {
                    id: userArea
                    anchors.top: parent.top
                    anchors.left: parent.left
                    anchors.right: parent.right
                    height: Math.max(iconArea.height, nameArea.height) + constants.listViewScrollbarWidth * 2

                    Item {
                        id: iconArea
                        anchors.left: parent.left
                        anchors.leftMargin: 12
                        anchors.top: parent.top
                        anchors.topMargin: 12
                        width: constants.listViewIconSize
                        height: width
                        Image {
                            anchors.fill: parent
                            source: 'http://api.twitter.com/1/users/profile_image?screen_name='.concat(verifyCredentials.screen_name).concat('&size=bigger')
                        }
                    }

                    Rectangle {
                        id: nameArea
                        anchors.left: iconArea.right
                        anchors.leftMargin: 12
                        anchors.right: parent.right
                        anchors.top: iconArea.top
                        color: "transparent"
                        Label {
                            id: lblScreenName
                            anchors.top: parent.top
                            anchors.topMargin: 4
                            anchors.left: nameArea.left
                            text: verifyCredentials.screen_name ? verifyCredentials.screen_name : ''
                            font.bold: true
                            platformStyle: LabelStyle { fontPixelSize: constants.fontDefault }
                        }
                        Label {
                            anchors.top: lblScreenName.bottom
                            anchors.left: nameArea.left
                            text: verifyCredentials.name ? verifyCredentials.name : ''
                            platformStyle: LabelStyle { fontPixelSize: constants.fontDefault }
                        }
                    }
                }
            }
        }
    }*/

    /*focus: true
    Keys.onPressed: {
        if (event.key == Qt.Key_Right) {
            if (window.pageStack.currentPage === mainPage)
            {
                mainPage.changeTabsToRight();
                event.accepted = true;
            } else {
                event.accepted = true;
            }
        } else if (event.key == Qt.Key_Left) {
            if (window.pageStack.currentPage === mainPage)
            {
                mainPage.changeTabsToLeft();
                event.accepted = true;
            } else {
                event.accepted = true;
            }
        } else {
            pageStack.push(tweetPage, {'statusText': event.text});
            event.accepted = true;
        }
    }*/

    TweetMarker {
        id: tweetMarker
        verifyCredentialsFormat: 'json'
    }

    Timer {
        id: loadedTimer
        running: true
        interval: 5000
        repeat: false
    }

    Component {
        id: notification;
        Notification {}
    }

    HapticsEffect {
        id: rumbleEffect
        attackIntensity: 0.0
        attackTime: 250
        intensity: 1.0
        duration: 500
        fadeTime: 250
        fadeIntensity: 0.0
    }

    Component {
        id: eventFeed
        EventFeed {}
    }

    UIConstants {
        id: constants
        fontDefault: settings.readData('Appearance/FontSize', 24)
        onFontDefaultChanged: settings.saveData('Appearance/FontSize', constants.fontDefault)
    }

    Column {
        id: infoBanners
        y: window.inPortrait ? 110 : 85
        anchors.left: parent.left
        anchors.right: parent.right
        spacing: 8

        /*function followedBy(status) {
            var component = notification.createObject(window)
            component.eventType = 'rocket.followedby'
            window.clearNotifications(component)
            component.summary = status.source.name
            component.body = '@'+status.source.screen_name + ' following you'
            component.identifier = 'followedby'
            component.publish()
            if (settings.readData('Notifications/HapticsFeedback', false))
                rumbleEffect.start()
        }*/

        /*function followedBy(status) {
            if (status.source.id_str === oauth.user_id) return
            var properties = {
                text: qsTr('@%1 following you').arg(status.source.screen_name)
                , iconSource: status.source.profile_image_url
                , page: userPage
                , properties: { id_str: status.source.id_str }
            }
            infoBannerComponent.createObject(infoBanners, properties).show()
        }

        function favorited(status) {
            if (status.source.id_str === oauth.user_id) return
            var properties = {
                text: qsTr('@%1 favorited your tweet\n%2').arg(status.source.screen_name).arg(status.target_object.text)
                , iconSource: status.source.profile_image_url
                , page: statusPage
                , properties: { id_str: status.target_object.id_str }
            }
            infoBannerComponent.createObject(infoBanners, properties).show()
        }*/

        function message(msg) {
            var properties = {
                text: msg
            }
            infoBannerComponent.createObject(infoBanners, properties).show()
        }

        function messageWithIcon(msg, icon) {
            var properties = {
                text: msg,
                iconSource: icon
            }
            infoBannerComponent.createObject(infoBanners, properties).show()
        }
    }

    ListMembersModel {
        id: mute
        owner_screen_name: oauth.screen_name
        slug: 'mute'
        property variant ids: settings.readData('Mute/IDs', '0').split(',')
        onIdsChanged: settings.saveData('Mute/IDs', ids.join(','))

        onNext_cursorChanged: console.debug('onNextCursorChanged', nextCursor)
        onNext_cursor_strChanged: console.debug('onNext_cursor_strChanged', cursor, nextCursorStr)
        onPrevious_cursorChanged: console.debug('onPreviousCursorChanged', previousCursor)
        onPrevious_cursor_strChanged: console.debug('onPreviousCursorStrChanged', previousCursorStr)

        Timer {
            interval: 100
            repeat: false
            running: !mute.loading
            onTriggered: {
                if (mute.next_cursor_str == '') {
                    // error
                } else if (mute.next_cursor_str != '0') {
                    mute.cursor = mute.next_cursor_str
                    mute.reload()
                } else {
                    mute.ids = mute.idList
                }
            }
        }
    }

    property bool active: platformWindow.viewMode === WindowState.Fullsize && platformWindow.visible && platformWindow.active
    onActiveChanged: {
        if (active) {
            clearNotifications();
        }
    }

    function clearNotifications(component) {
        var create = (typeof component === 'undefined')
        if (create)
            component = notification.createObject(window)
        var notifications = component.notifications()
        for (var i = 0; i < notifications.length; i++) {
            if (!create && component.eventType !== notifications[i].eventType)
                continue
            notifications[i].remove()
            notifications[i].destroy()
        }
        if (create)
            component.destroy()
    }

    Component {
        id: infoBannerComponent
        InfoBanner {
            id: infoBanner
            timerEnabled: platformWindow.viewMode === WindowState.Fullsize && platformWindow.visible && platformWindow.active
            timerShowTime: 5000
            property Component page
            property variant properties

            onScaleChanged: {
                if (scale == 0 && infoBanner.text.length > 0) {
                    infoBanner.destroy()
                }
            }

            MouseArea {
                anchors.fill: parent
                onClicked: {
                    if (mouse.x < width - height && infoBanner.page) {
                    pageStack.push(infoBanner.page, infoBanner.properties)
                    }
                    infoBanner.hide()
                }
            }
        }
    }

    property variant mediaSelected
    property variant locationSelected

    SettingsStorage {
        id: profiles
        identifier: 'Profiles'
        description: 'http://webpointstudio.ru/rocket'
    }

    SettingsStorage {
        id: settings
        identifier: profiles.readData('RocketProfile', '')
        description: 'http://webpointstudio.ru/rocket'
        onIdentifierChanged: {
            if (settings.identifier.length > 0) {
                profiles.saveData('RocketProfile', settings.identifier)
                /*oauth.token = settings.readData('OAuth/Token', '')
                oauth.token_secret = settings.readData('OAuth/TokenSecret', '')
                oauth.user_id = settings.readData('OAuth/UserId', '')
                oauth.screen_name = settings.readData('OAuth/ScreenName', '')*/
            } else {
                oauth.request_token("http://webpointstudio.ru/auth_success")
                pageStack.push(authorizationPage)
            }
        }
    }

    //Test { id: test; property bool online: networkConfigurationManager.online && test.ok }
    QtObject {
        id: test
        property bool online: networkConfigurationManager.online && test.ok
        property bool ok: false
        function exec() {
            var request = new XMLHttpRequest()
            request.open('GET', 'https://api.twitter.com/1.1/help/tos.json')
            request.setRequestHeader("Content-Type", "application/json")
            request.onreadystatechange = function() {
                if( request.readyState === XMLHttpRequest.HEADERS_RECEIVED && request.status !== 0 ) {
                    test.ok = true
                }
            }
            request.send()
        }
    }

    /*RateLimitStatus {
        id: rls
        property string hhmm
        onLoadingChanged: {
            if (loading) return
            if (remaining_hits > 0 || reset_time.length == 0) return
            hhmm = Qt.formatDateTime(new Date(reset_time), 'hh:mm')
            infoBanners.message({'text': qsTr('API rate limited until %1').arg(hhmm)})
        }
    }*/

    Timer {
        running: networkConfigurationManager.online && !test.ok //&& constants.streaming
        interval: 30 * 1000
        triggeredOnStart: true
        repeat: true
        onTriggered: test.exec()
    }

    Timer {
        running: !constants.streaming && interval > 0 && !test.online
        interval: constants.updateInterval * 60 * 1000
        repeat: true
        onTriggered: test.exec()
    }

    VerifyCredentials {
        id: verifyCredentials
    }

    Configuration {
        id: configuration
    }

    NoRetweetIdsModel { id: noRetweetIds }

    property variant friends: []

    property variant filters: settings.readData('Filters', '').split(/\n/)
    property variant user_filters: []
    property variant hashtag_filters: []
    property variant url_filters: []
    property variant text_filters: []

    onFiltersChanged: {
        var user_filters = []
        var hashtag_filters = []
        var url_filters = []
        var text_filters = []
        for (var i = 0; i < window.filters.length; i++) {
            var f = window.filters[i]
            if (f[0] === '@') {
                user_filters.push(f.substring(1).toLowerCase())
            } else if (f[0] === '#') {
                hashtag_filters.push(f.substring(1).toLowerCase())
            } else if (f.substring(0, 7) === 'http://' || f.substring(0, 8) === 'https://') {
                url_filters.push(f)
            } else if (f.length > 0){
                text_filters.push(f.toLowerCase())
            }
        }

        window.user_filters = user_filters
        window.hashtag_filters = hashtag_filters
        window.url_filters = url_filters
        window.text_filters = text_filters
        settings.saveData('Filters', window.filters.join('\n'))
    }

    function filter(item) {
        var status = item
        if (typeof item.retweeted_status !== 'undefined') {
            if (noRetweetIds.idList.indexOf(item.user.id_str) > -1) return true
            status = item.retweeted_status
        }
        var entities = status.entities
        var text = status.plain_text.toLowerCase()

        if (typeof status.user !== 'undefined') {
            if (user_filters.indexOf(item.user.screen_name.toLowerCase()) > -1) return true
            if (typeof entities !== 'undefined' && typeof entities.user_mentions.length !== 'undefined') {
                for (var i = 0; i < entities.user_mentions.length; i++) {
                    if (user_filters.indexOf(entities.user_mentions[i].screen_name.toLowerCase()) > -1) return true
                }
            }
        }

        if (typeof entities !== 'undefined' && typeof entities.hashtags.length !== 'undefined') {
            for (var i = 0; i < entities.hashtags.length; i++) {
                if (hashtag_filters.indexOf(entities.hashtags[i].text.toLowerCase()) > -1) return true
            }
        }

        if (typeof entities !== 'undefined' && typeof entities.urls.length !== 'undefined') {
            for (var i = 0; i < entities.urls.length; i++) {
                var url = entities.urls[i].expanded_url.toLowerCase()
                for (var j = 0; j < url_filters.length; j++) {
                    if (url.substring(0, url_filters[j].length) === url_filters[j]) return true
                }
            }
        }

        for (var i = 0; i < text_filters.length; i++) {
            if (text.indexOf(text_filters[i]) > -1) return true
        }

        return false;
    }

    OAuth {
        id: oauth
        consumer_key: consumerKey
        consumer_secret: consumerSecret
        token: settings.readData('OAuth/Token', '')
        token_secret: settings.readData('OAuth/TokenSecret', '')
        user_id: settings.readData('OAuth/UserId', '')
        screen_name: settings.readData('OAuth/ScreenName', '')

        onTokenChanged: { settings.saveData('OAuth/Token', token) }
        onToken_secretChanged: { settings.saveData('OAuth/TokenSecret', token_secret) }
        onUser_idChanged: { settings.saveData('OAuth/UserId', user_id); }
        onScreen_nameChanged: { settings.saveData('OAuth/ScreenName', screen_name) }

        property bool completed: false
        onStateChanged: {
            switch (state) {
            case OAuth.Authorized:
                if (completed) {
                    verifyCredentials.exec()
                    configuration.exec()
                    settings.identifier = oauth.screen_name;
                }
                break;
            case OAuth.Unauthorized:
                if (completed) {
                    settings.saveData('Mute/IDs', '')
                    settings.saveData('MentionsPage/maxLoadedIdStr', '')
                }
                break;
            }
        }
        Component.onCompleted: oauth.completed = true;
    }

    initialPage: mainPage

    SavedSearchesModel {
        id: savedSearchesModel
        property variant searchTerms: []
        onSizeChanged: {
            var searchTerms = []
            for (var i = 0; i < size; i++) {
                searchTerms.push(get(i).query.toLowerCase())
            }
            savedSearchesModel.searchTerms = searchTerms
        }
    }

    FilterStreamModel {
        id: filterStream
        track: savedSearchesModel.searchTerms.join(',')
    }

    Component { id: welcomePage; WelcomePage {} }
    Component { id: authorizationPage; AuthorizationPage {} }
    Component { id: flickrAuthPage; FlickrAuthPage {} }
    Component { id: mainPage; MainPage {} }
    Component { id: userPage; UserPage {} }
    Component { id: statusPage; StatusPage {} }
    Component { id: tweetPage; TweetPage { id: tweetEditor; } }
    Component { id: searchPage; SearchPage {} }
    Component { id: previewPage; PreviewPage {} }
    Component { id: userTimelinePage; UserTimelinePage {} }
    Component { id: favouritesPage; FavouritesPage {} }
    Component { id: followingPage; FollowingPage {} }
    Component { id: followersPage; FollowersPage {} }
    Component { id: directMessagePage; DirectMessagePage {} }
    Component { id: sendDirectMessagePage; SendDirectMessagePage {} }
    Component { id: listsPage; ListsPage {} }
    Component { id: listedPage; ListedPage {} }
    Component { id: listStatusesPage; ListStatusesPage {} }
    Component { id: listDetailPage; ListDetailPage{} }
    Component { id: selectMediaPage; SelectMediaPage {} }
    Component { id: cameraPage; CameraPage {} }
    Component { id: savedSearchesPage; SavedSearchesPage{} }
    Component { id: accountPage; AccountPage{} }
    Component { id: newSearchPage; NewSearchPage{} }
    Component { id: suggestionsPage; SuggestionsPage{} }
    Component { id: searchUsersPage; SearchUsersPage{} }
    Component { id: settingsPage; SettingsPage{} }
    Component { id: selectVenuePage; SelectVenuePage{} }
    Component { id: mapPage; MapPage{} }
    Component { id: aboutPage; AboutPage{} }
    Component { id: mutePage; MutePage{} }

    Component { id: pocketPage; PocketService{} }
    Component { id: instapaperPage; InstapaperService{} }
    Component { id: deliciousPage; DeliciousService{} }
    TextEdit { id: clipboard; visible: false }

    showStatusBar: {
        if (settings.readData('Application/showStatusBar', true))
            return (screen.currentOrientation === Screen.Portrait);
        else
            return false;
    }

    Component.onCompleted: {
        qDBusServer.visible = true
        /*if (settings.readData('Application/lockOrientation', false))
            screen.allowedOrientations = Screen.Portrait;
        else
            screen.allowedOrientations = Screen.Default;*/
        /*if (settings.readData('Application/showStatusBar', true))
        {
            if (screen.currentOrientation === Screen.Portrait)
                window.showStatusBar = true;
            else
                window.showStatusBar = false;
        }
        else
            window.showStatusBar = false;*/
        theme.inverted = settings.readData('Application/visualTheme', false)
        qDBusServer.getData();

        try {
            //maemo5 specific lib hack
            window.allowSwitch  = false;
            window.allowClose = false;
        } catch(err) {
            console.log("MAEMO: cannot setup window hacks");
        }
    }
}
